/*
** InOut.c for Gmurf in ~/Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Tue Feb 16 19:10:59 1999 Rmi Coupet
** Last update Thu Mar 18 13:57:38 1999 Rmi Coupet
*/
#include "InOut.h"


static char File_Def[256] = "";


void 		save_project		(GtkWidget	*widget) ;
void 		render_project		(GtkWidget	*widget) ;
void 		open_project		(GtkWidget	*widget) ;
void           save_wave                (GtkWidget      *widget,
					 gpointer       data) ;

typedef struct s_file_save t_file_save ;
struct s_file_save {
  GtkWidget *fs ;
  GtkWidget *ww ;
} ;

GtkWidget	*File_Select(Message, 
			     def_file, 
			     way)
const char	*Message ;
char		*def_file ;
int		way ;
{
  GtkWidget 	*fs;  

  fs = gtk_file_selection_new(Message);
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), def_file);
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);
  gtk_signal_connect_object (GTK_OBJECT (fs), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (fs));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fs));
  if (way == WAV_OPEN)
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			      "clicked", GTK_SIGNAL_FUNC (open_verify),
			      GTK_OBJECT (fs));
  else if (way == MIX_OPEN)
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			      "clicked", GTK_SIGNAL_FUNC (open_verify_mix),
			      GTK_OBJECT (fs));
  else
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			      "clicked", GTK_SIGNAL_FUNC (open_verify_both),
			      GTK_OBJECT (fs));
  gtk_widget_show(fs);
  return (fs) ;
}

GtkWidget	*File_Save_Wave(widget)
GtkWidget	*widget ;
{
  GtkWidget 	*fs;  
  t_file_save   *data ;

  data = (t_file_save   *) malloc(sizeof(t_file_save)) ;

  fs = gtk_file_selection_new("Save Project :");
  
  data->fs = fs ;
  data->ww = widget ;

  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), WAVWIN(widget)->tempgmurf->origname);
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);
  gtk_signal_connect_object (GTK_OBJECT (fs), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (fs));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fs));

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
		     "clicked", GTK_SIGNAL_FUNC (save_wave),
		     (gpointer) data);
  gtk_widget_show(fs);
  return(fs);
}

GtkWidget	*File_Save_Project()
{
  GtkWidget 	*fs;  

  fs = gtk_file_selection_new("Save Project :");
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), "Untitled");
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);
  gtk_signal_connect_object (GTK_OBJECT (fs), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (fs));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fs));

  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			    "clicked", GTK_SIGNAL_FUNC (save_project),
			    GTK_OBJECT (fs));
  gtk_widget_show(fs);
  return(fs);
}


GtkWidget	*File_Render_Project()
{
  GtkWidget 	*fs;  

  fs = gtk_file_selection_new("Render Project :");
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), "Untitled.wav");
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);
  gtk_signal_connect_object (GTK_OBJECT (fs), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (fs));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fs));

  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			    "clicked", GTK_SIGNAL_FUNC (render_project),
			    GTK_OBJECT (fs));
  gtk_widget_show(fs);
  return(fs);
}


GtkWidget	*File_Open_Project()
{
  GtkWidget 	*fs;  

  fs = gtk_file_selection_new("Open Project :");
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), "Untitled");
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);
  gtk_signal_connect_object (GTK_OBJECT (fs), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (fs));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fs));

  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
			    "clicked", GTK_SIGNAL_FUNC (open_project),
			    GTK_OBJECT (fs));
  gtk_widget_show(fs);
  return(fs);
}

void 	want_you_open_project()
{
  if ( MIXER(Global_Mixer)->ms_list != NULL )
    Cancel_dialog_box("It will destroy your current project !!", 
		      MainWindow, File_Open_Project) ;
  else 
    File_Open_Project() ;
}

  
void 		save_project(widget)
GtkWidget	*widget ;
{
  char 	*str ;
  int	i ;
  char 	*dir ;
  char	*fich ;
  
  str = gtk_file_selection_get_filename (GTK_FILE_SELECTION (widget)) ;
  for (i = strlen(str) -1; (i > 0)  && (str[i] != '/') ; i--) ;
  if (i == strlen(str) -1)
    Error_dialog_box("Can't create a file with no name !", MainWindow) ;
  else
  {
    dir = (char *) malloc(sizeof(char) * (i + 1)) ;
    fich = (char *) malloc(sizeof(char) * (strlen(str) - i +1)) ;
    strncpy(dir, str, i) ;
    dir[i] = '\0' ;
    fich = str + i + 1 ;
    if (project_save_file(MIXER(Global_Mixer)->Main_Mixer, dir, fich, 
			  MIXER(Global_Mixer)->gmurfrc) < 0 )
      Error_dialog_box("Can't Save Project", MainWindow) ;
    else
      gtk_widget_destroy(widget) ;
  }
}


void 		render_project(widget)
GtkWidget	*widget ;
{
  char 		*str ;
  int		i ;
  t_renderer	*rend ;

  str = gtk_file_selection_get_filename (GTK_FILE_SELECTION (widget)) ;
  for (i = strlen(str) -1; (i > 0)  && (str[i] != '/') ; i--) ;
  if (i == strlen(str) -1)
    Error_dialog_box("Can't create a file with no name !", MainWindow) ;
  else
  {
    rend = renderer_new(MIXER(Global_Mixer)->Main_Mixer, str) ;
    if (rend == NULL )
      Error_dialog_box("Can't Save Project", MainWindow) ;
    else
    {
      while (renderer_update(rend) != 0)
	;
      renderer_destroy(rend) ;
      gtk_widget_destroy(widget) ;
    }
  }
}


void 		open_project(widget)
GtkWidget	*widget ;
{
  char 		*str ;
  char 		*fich ;
  char 		*dir ;
  int		i ;
  t_mixer_elt	*elt ;

  str = gtk_file_selection_get_filename (GTK_FILE_SELECTION (widget)) ;
  for (i = strlen(str) -1; (i > 0)  && (str[i] != '/') ; i--) ;
  if (i == strlen(str) -1)
    Error_dialog_box("Can't open a file with no name !", MainWindow) ;
  else
  {
    while ( MIXER(Global_Mixer)->ms_list != NULL )
      close_ms(GTK_WIDGET (MIXER(Global_Mixer)->ms_list->ms)) ;
    dir = (char *) malloc(sizeof(char) * (i + 1)) ;
    fich = (char *) malloc(sizeof(char) * (strlen(str) - i +1)) ;
    strncpy(dir, str, i) ;
    dir[i] = '\0' ;
    fich = str + i + 1 ;
    
    project_load(dir, fich, MIXER(Global_Mixer)->Main_Mixer, 
		 MIXER(Global_Mixer)->gmurfrc) ;

    elt = MIXER(Global_Mixer)->Main_Mixer->first_mixer_elt ;
    while (elt != NULL)
    {
      Open_mix_sample(elt->tempgmurf, elt) ;
      elt = elt->next_mixer_elt ;
    }

    gtk_widget_destroy(widget) ;
  }
}


char		*itoa(i)
signed long	i ;
{
  char		*str ;
  int		j ;
  char		fin = 0;
  long		absolute ;
  
  if (i == 0)
  {
    str = (char *) malloc(2 * sizeof(char)) ;
    str[0] = '0' ;
    str[1] = '\0' ;
    return str ;
  }
  absolute = (long int) log10(abs(i)) ;
  str = (char *) malloc(absolute + (i < 0 ? 3 : 2)) ;
  if (i < 0)
  {
    str[0] = '-';
    fin = 1 ;
  }
  for (j = absolute + fin; j >= fin ; j--)
  {
    str[j] = abs(i) % 10 + '0';
    i /= 10 ;
  }
  str[absolute + fin + 1] = '\0' ;
  return str ;
}


char		*ultoa(i)
unsigned long	i ;
{
  char		*str ;
  int		j ;
  long		absolute ;
  
  if (i == 0)
  {
    str = (char *) malloc(2 * sizeof(char)) ;
    str[0] = '0' ;
    str[1] = '\0' ;
    return str ;
  }
  absolute = (unsigned long int) log10(i) ;
  str = (char *) malloc(absolute + 2) ;
  for (j = absolute ; j >= 0 ; j--)
  {
    str[j] = abs(i) % 10 + '0';
    i /= 10 ;
  }
  str[absolute + 1] = '\0' ;
  return str ;
}


void		open_verify(fs)
GtkWidget	*fs ;
{
  t_tempgmurf	*gmurf ;
  char		*tmp_file_name ;
  int 		i ;
  char 		*user ;
  char		*tmp_dir ;
  static int	numero = 0 ;

  strcpy(File_Def, gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gmurf = (t_tempgmurf *) malloc(sizeof (t_tempgmurf));
  for (i = strlen(File_Def) -1; (i >= 0) && (File_Def[i] != '/') ; i-- );
  if (File_Def[i] == '/')
    i++ ;

  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 3) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;
  strcat(tmp_dir, "/") ;

  tmp_file_name = (char *) malloc(sizeof(char) * (strlen(File_Def) - i + 1
						  + strlen(tmp_dir) + 
						  strlen(itoa(numero))+1)) ;
  strcpy(tmp_file_name, tmp_dir) ;
  strcat(tmp_file_name, File_Def + i);
  strcat(tmp_file_name, itoa(numero++)) ;  
  gmurf = charge_sound_file(File_Def, tmp_file_name, 
			    MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate);
  
  free(tmp_dir) ;

  if (gmurf == NULL) 
  {
    if (gmurf_errno == NULL) 
      Error_dialog_box(REMI_CANT_OPEN, MainWindow);
    else
      Error_dialog_box(gmurf_errno, MainWindow); 
  } else
  {
    gtk_widget_destroy(fs);
    gmurf->connected = IN_WE ;
    new_wav_editor(gmurf) ;
  }
}


void		open_verify_mix(fs)
GtkWidget	*fs ;
{
  t_tempgmurf	*gmurf ;
  char		*tmp_file_name ;
  int 		i ;
  char		*user ;
  char		*tmp_dir ;
  static int	numero = 3000 ;

  strcpy(File_Def, gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gmurf = (t_tempgmurf *) malloc(sizeof (t_tempgmurf));
  for (i = strlen(File_Def) -1; (i >= 0) && (File_Def[i] != '/') ; i-- );
  if (File_Def[i] == '/')
    i++ ;
  
  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 3) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;
  strcat(tmp_dir, "/") ;

  tmp_file_name = (char *) malloc(sizeof(char) * (strlen(File_Def) - i + 1
						   + strlen(tmp_dir) + 
						  strlen(itoa(numero))+1)) ;
  strcpy(tmp_file_name, tmp_dir) ;
  strcat(tmp_file_name, File_Def + i);  
  strcat(tmp_file_name, itoa(numero++)) ;
  gmurf = charge_sound_file(File_Def, tmp_file_name,
			    MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate);

  free(tmp_dir) ;  

  if (gmurf == NULL)
    if (gmurf_errno == NULL) 
      Error_dialog_box(REMI_CANT_OPEN, MainWindow);
    else
      Error_dialog_box(gmurf_errno, MainWindow) ; 
  else
  {
    gtk_widget_destroy(fs);
    gmurf->connected = IN_MIXER ;
    Create_mix_sample(gmurf);
  }
}


void		open_verify_both(fs)
GtkWidget	*fs ;
{
  t_tempgmurf	*gmurf ;
  char		*tmp_file_name ;
  int 		i ;
  char		*tmp_dir ;
  char		*user ;
  static int	numero = 7000 ;

  strcpy(File_Def, gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gmurf = (t_tempgmurf *) malloc(sizeof (t_tempgmurf));
  for (i = strlen(File_Def) -1; (i >= 0) && (File_Def[i] != '/') ; i-- );
  if (File_Def[i] == '/')
    i++ ;

  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 3) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;
  strcat(tmp_dir, "/") ;

  tmp_file_name = (char *) malloc(sizeof(char) * (strlen(File_Def) - i + 1
						   + strlen(tmp_dir)
						 + strlen(itoa(numero))+1)) ;
  strcpy(tmp_file_name, tmp_dir) ;
  strcat(tmp_file_name, File_Def + i);  
  strcat(tmp_file_name, itoa(numero++)) ;
  gmurf = charge_sound_file(File_Def, tmp_file_name, 
			    MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate);
  free(tmp_dir) ;
  
  if (gmurf == NULL)
    if (gmurf_errno == NULL) 
      Error_dialog_box(REMI_CANT_OPEN, MainWindow);
    else
      Error_dialog_box(gmurf_errno, MainWindow) ; 
  else
  {
    gtk_widget_destroy(fs);
    gmurf->connected = IN_BOTH ;
    connect_with_wav_editor(gmurf, MIX_SAMPLE (Create_mix_sample(gmurf)));
  }
}


GtkWidget	*file_save(filename)
char		*filename ;     
{
  GtkWidget *fs;

  fs = File_Select ("Save File:", File_Def, 0);
  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs), filename);
  gtk_entry_select_region 
    (GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry),
     0, GTK_ENTRY(GTK_FILE_SELECTION(fs)->selection_entry)->text_length);  
  return fs;
}


void	open_in_WE(void) 
{
  File_Select("Open File :", File_Def, WAV_OPEN);
}

void	open_in_MIX(void) 
{
  File_Select("Open File :", File_Def, MIX_OPEN);
}

void	open_in_BOTH(void) 
{
  File_Select("Open File :", File_Def, BOTH_OPEN);
}

void           save_wave(widget, data)
GtkWidget      *widget ;
gpointer       data ;
{
  t_file_save *dat ;
  char *str ;

  dat = (t_file_save *) data ;
  str = gtk_file_selection_get_filename (GTK_FILE_SELECTION (dat->fs)) ;
   save_sound_file(WAVWIN(dat->ww)->tempgmurf, 
		  MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate, 
		  str);
  gtk_widget_destroy(dat->fs) ;
}
