#include "main.h"

GtkWidget 	*MainWindow;
GtkWidget	*Global_Mixer ;

void		create_gmurfrc(FILE	*fich) ;

void	mk_swap_file(temp_dir)
char	*temp_dir;
{
  temp_file    = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(TEMP_FILE_NAME) + 1));
  strcpy(temp_file, temp_dir);
  strcat(temp_file, TEMP_FILE_NAME);
  swap_file    = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(SWAP_FILE_NAME) + 1));
  strcpy(swap_file, temp_dir);
  strcat(swap_file, SWAP_FILE_NAME);
  undo_file    = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(UNDO_FILE_NAME) + 1));
  strcpy(undo_file, temp_dir);
  strcat(undo_file, UNDO_FILE_NAME);
  redo_file    = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(REDO_FILE_NAME) + 1));
  strcpy(redo_file, temp_dir);
  strcat(redo_file, REDO_FILE_NAME);
  select_file  = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(SELECT_FILE_NAME) + 1));
  strcpy(select_file, temp_dir);
  strcat(select_file, SELECT_FILE_NAME);
  src_file  = (char *) malloc(sizeof(char) * (strlen(temp_dir) + strlen(SRC_FILE_NAME) + 1));
  strcpy(src_file, temp_dir);
  strcat(src_file, SRC_FILE_NAME);
   
}

int	main (argc, 
	      argv)
int	argc ;
char	**argv;
{
  t_gmurfrc	*gmurfrc ;
  t_filters	*filter ;
  char		*user ;
  char 		*tmp_dir ;
  FILE		*fich ;
  int		etat ;

  gtk_init (&argc, &argv);

/*************** Make Directory /tmp/Gmurf_$USER ***************/

  user = getenv("USER") ;
  tmp_dir = (char *) malloc(strlen(user) + strlen(TMP_GMURF_DIR) + 2) ;
  strcpy(tmp_dir, TMP_GMURF_DIR);
  strcat(tmp_dir, "_") ;
  strcat(tmp_dir, user) ;

  if (mkdir(tmp_dir , 0711) == -1) 
    if (errno != EEXIST) {
      printf("%s errno : %d\n", CANT_CREATE_TMP, errno);
      exit (1) ;
    }
  mk_swap_file(tmp_dir);
  free(tmp_dir);
  
/*********** Make Directory ~/.gmurf *********************/
  
  tmp_dir = (char *) malloc ( sizeof(char) * (strlen(getenv("HOME")) + 8) ) ;
  strcpy(tmp_dir, getenv("HOME")) ;
  strcat(tmp_dir, "/.gmurf") ;
  if (mkdir(tmp_dir , 0711) == -1) 
    if (errno != EEXIST) {
      printf("%s errno : %d\n", "can't create ~/.gmurf", errno);
      exit (1) ;
    }

/************ If gmurf.rc doesn't exist, build one ************/

  user = (char *) malloc ( sizeof(char) * (strlen(tmp_dir) + 10) ) ;
  strcpy(user, tmp_dir) ;
  strcat(user, "/gmurf.rc");
  if ( (etat = open(user, O_WRONLY | O_CREAT | O_EXCL)) != -1 )
  {  
    close(etat) ;
    fich = fopen(user, "w") ;
    create_gmurfrc(fich) ;
    fclose(fich) ;
    gtk_rc_parse(user);
  }
  else if (errno == EEXIST)
    gtk_rc_parse(user);
  else 
  {
    printf("Can't create ~/gmurf/gmurf.rc\n") ;
    printf("Make the necessary if you don't want to keep this horrible gray !\n") ;
  }
  
  free(tmp_dir) ;
  free(user) ;

/**************** Dsps Init ********************/

  if ((gmurfrc = gmurfrc_defaults()) == NULL)
  {
    printf("You haven't got any Dsps opened !\n\tSee you\n");
    exit(1) ;
  }

  test_sound_file_loader() ;
  if ((filter = get_filter_path(FILTER_LOADER)) == NULL )
    exit(-1) ;
  
  
  MainWindow = create_principal_window (MAIN_WIDTH, MAIN_HEIGHT, 0, "!! Gmurf !!");
  gtk_widget_show(MainWindow);
  gtk_widget_set_name (MainWindow, "main window");

  Global_Mixer = Create_Mixer();

  MIXER (Global_Mixer)->gmurfrc = gmurfrc ;
  MIXER (Global_Mixer)->filters = filter ;
  MIXER (Global_Mixer)->Main_Mixer = 
    new_main_mixer(MIXER (Global_Mixer)->gmurfrc->first_dsp_in_list,
		   DEFAULT_VOLUME,	
		   DEFAULT_PANNING,
		   MIXER (Global_Mixer)->gmurfrc->first_dsp->sample_rate,
		   DEFAULT_MAX_VOICES);

  gtk_container_add (GTK_CONTAINER (MainWindow), Global_Mixer);
  gtk_main();
  
  return 0;
}

void		create_gmurfrc(fich) 
FILE		*fich ;
{
  fprintf(fich, "pixmap_path \""DEF_PATH"/pixmaps\"\n") ;
  fprintf(fich, "style \"window\"\n") ;
  fprintf(fich, "{\n") ;
  fprintf(fich, "  bg_pixmap[NORMAL] = \"revefam.xpm\"\n") ;
  fprintf(fich, "}\n") ;

  fprintf(fich, "style \"main\"\n") ;
  fprintf(fich, "{\n") ;
  fprintf(fich, "  bg_pixmap[NORMAL] = \"snow.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[ACTIVE] = \"revefam.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[PRELIGHT] = \"revefam.xpm\"	\n") ;
  fprintf(fich, "}\n") ;

  fprintf(fich, "style \"dialog\"\n") ;
  fprintf(fich, "{\n") ;
  fprintf(fich, "  bg_pixmap[NORMAL] = \"savon.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[ACTIVE] = \"revefam.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[PRELIGHT] = \"revefam.xpm\"	\n") ;

  fprintf(fich, "}\n") ;

  fprintf(fich, "style \"button\"\n") ;
  fprintf(fich, "{\n") ;
  fprintf(fich, "  bg_pixmap[NORMAL] = \"revefam.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[ACTIVE] = \"mrbl1pap.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[PRELIGHT] = \"mrbl1pap.xpm\"	\n") ;
  fprintf(fich, "}\n") ;

  fprintf(fich, "style \"button dialog\"\n") ;
  fprintf(fich, "{\n") ;
  fprintf(fich, "  bg_pixmap[NORMAL] = \"savon.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[ACTIVE] = \"mrbl1pap.xpm\"\n") ;
  fprintf(fich, "  bg_pixmap[PRELIGHT] = \"mrbl1pap.xpm\"	\n") ;
  fprintf(fich, "}\n") ;

  fprintf(fich, "widget \"main window\" style \"main\"\n") ;
  fprintf(fich, "widget \"scrolled window\" style \"main\"\n") ;
  fprintf(fich, "widget \"root menu\" style \"main\"\n") ;
  fprintf(fich, "widget \"mixer\" style \"main\"\n") ;
  fprintf(fich, "widget \"mixer.*GtkHScrollBar*\" style \"main\"\n") ;
  fprintf(fich, "widget \"mixer.*GtkVScrollBar*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkVBox*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkHBox*\" style \"main\"\n") ;
  fprintf(fich, "widget \"scrolled window.*GtkHBox*\" style \"main\"\n") ;
  fprintf(fich, "widget \"scrolled window.*GtkVBox*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkButton*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkRadioButton*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkMenuBar*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkMenuItem*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkProgressBar*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkHScale*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkScrolledWindow*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkHScrollBar*\" style \"main\"\n") ;
  fprintf(fich, "widget \"main window.*GtkVScrollBar*\" style \"main\"\n") ;

  fprintf(fich, "widget \"wav editor\" style \"window\"\n") ;
  fprintf(fich, "widget \"wav menubar\" style \"window\"\n") ;
  fprintf(fich, "widget \"wav toolbar\" style \"window\"\n") ;
  fprintf(fich, "widget \"note label\" style \"window\"\n") ;
  fprintf(fich, "widget \"note table\" style \"window\"\n") ;
  fprintf(fich, "widget \"wav notebook\" style \"window\"\n") ;
  fprintf(fich, "widget \"wav editor.*GtkButton*\" style \"button\"\n") ;
  fprintf(fich, "widget \"wav editor.*GtkRadioButton*\" style \"button\"\n") ;
  fprintf(fich, "widget \"wav editor.*GtkToggleButton*\" style \"button\"\n") ;
  fprintf(fich, "widget \"wav editor.*GtkMenuItem*\" style \"button\"\n") ;
  fprintf(fich, "widget \"wav editor.*GtkMenu*\" style \"button\"\n") ;
  fprintf(fich, "widget \"dialog box\" style \"dialog\"\n") ;
}













